<?php
declare(strict_types=1);

namespace Inti\Wp\Plugin\Core;

use Inti\Wp\Plugin\PluginInterface;
use JsonException;
use Psr\Container\ContainerInterface;
use function file_get_contents;
use function json_decode;

/**
 * Class AssetsFactory
 *
 * @package Inti\Wp\Plugin\Core
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/inti-wp
 */
final class AssetsFactory
{
    /**
     * @param ContainerInterface $container
     * @return PluginInterface
     * @throws JsonException
     */
    public function __invoke(ContainerInterface $container): PluginInterface
    {
        $config = $container->has('config') ? $container->get('config') : [];

        $manifest = file_get_contents($config['wp']['assets']['manifest_path']);
        $manifest = json_decode($manifest, true, 512, JSON_THROW_ON_ERROR);

        return new Assets($manifest, $config['wp']['assets']['dequeue'] ?? []);
    }
}
